// 7bit D/A test
// RB6-RB9 : output (b0-b3)
// RF4-RF6 : output (b4-b6)

#include <p30f2012.h>     // include dsPIC30F2012 header file
#include <math.h>         // include math library header file

//===============================================================
// t*10us delay

void delay10us(unsigned t) {
  unsigned i;

  for (i=0; i<t; i=i+1) {
    asm("repeat #284");            // for 29.48MHz clock
    asm("nop");
  }  
}

//===============================================================

void da7bit(unsigned char x) {
  PORTB=(x&0x000f)<<6;
  PORTF=x&0x0070;
}

//===============================================================

#define PERIOD 800
unsigned char x[PERIOD];

int main(void) {
  unsigned i;

  //ADPCFG=0xffff;                 // disable all A/D input pin
  TRISB=0xfc3f;                    // RB6-RB9 : output
  TRISF=0x008f;                    // RF4-RF6 : output

  for (i=0; i<PERIOD; i=i+1) {
    x[i]=64.0*(1.0+0.99*sin(2.0*3.1415926/PERIOD*i)); 
  }

  while(1) {                       // forever loop
    for (i=0; i<PERIOD; i=i+1) {
      da7bit(x[i]);
      delay10us(1);
    }
  }

}
