// printf() function test via UART
// *****************************
// * require heap size setting *
// *****************************

#include <p30F2012.h>
#include <stdio.h>
#include <float.h>

//------------------------------------------------------
// internal function for printf()

int write(int handle, void *buffer, unsigned int len) {
  int i;

  for (i=0; i<len; i=i+1) {
    while (U1STAbits.UTXBF!=0) {       // while not UART ready
      ;                                // nothing to do
    }
    U1TXREG=*(char *)buffer++;         // put character to UART
  }
  return(len);
}

//------------------------------------------------------

int main(void) {
  char rxd;                    

  U1MODE=0x8000;                       // UTX/URX(U1TX/U1RX), N81
  U1BRG =95;                           // 19200bps      
  U1STA =0x0400;                       // TX enable

  printf("Hello, Embedded System World!\r\n");        
  printf("Hit any key from keyboard\r\n");      

  while(1) {                           // forever loop
    if (U1STAbits.URXDA==1) {          // if incoming data exist
      rxd=U1RXREG;                     // read incoming character
      printf("%c", rxd);               // echo back
    }
  }

}


