// PWM control test
//   control data input : U1ARX/RC14(RS-232C input)
//   PWM output pin     : RB8/OC1

#include <p30f2012.h>           // include dsPIC30F2012 header file

int main(void) {
  unsigned command;             // received character
  unsigned width;               // pulse width 

  U1MODE=0x8400;                // use U1ARX 
  U1BRG =95;                    // 19200bps (29.48MHz/16/19200-1=95)

  //ADPCFG=0xffff;              // disable all A/D input pin
  TRISBbits.TRISB8=0;           // RB8(OC1) is output
  OC1RS  =0;                    // set duty parameter
  OC1R   =0x0000;               // clear OC1R
  OC1CON =0x0006;               // use Timer2 for PWM

  T2CON  =0x0000;               // without prescaler    
  PR2    =30000;                // set Timer2 period register
  TMR2   =0x0000;               // clear Timer2 counter register
  T2CONbits.TON=1;              // start Timer2

  while(1) {                    // forever loop
    if (U1STAbits.URXDA==1) {   // if incoming data exists
      command=U1RXREG;          // receive a charcater
      width=(command-'0')%10;   // width=0,1,2,...,9
      OC1RS=2800*(9-width);     // OC1RS=25200,22400,19600,...,0
    }
  }

}
