// RC servo control
//   control data input : U1ARX/RC14(RS-232C input)
//   output pin         : RB8(OC1)

#include <p30f2012.h>           // include dsPIC30F2012 header file

int main(void) {
  unsigned pw;

  U1MODE=0x8400;                // use U1ATX as RS-232C input
  U1BRG =95;                    // 19200bps (29.48MHz/16/19200-1=95)

  //ADPCFG=0xffff;              // disable all A/D input pin

  TRISBbits.TRISB8=0;           // RB8(OC1) is output
  T2CON =0x0020;                // use 1:64 prescaler for Timer2   
  PR2   =10000;                 // set Timer2 period register
  OC1RS =700;                   // set duty parameter
  OC1CON=0x0006;                // use Timer2 for PWM
  T2CONbits.TON=1;              // start Timer2

  while(1) {                    // forever loop
    if (U1STAbits.URXDA==1) {   // if RS-232C RX data exist
      pw=U1RXREG;               // read RX data
      pw=(pw-'0')%10;           // limit pw (0-9)
      OC1RS=460+50*pw;          // update pulse width
    }
  }

}
